DEPLOYMENT INSTRUCTIONS
=======================

Current production servers 
--------------------------
1. xmpp1.chat.pw
2. xmpp2.chat.pw

Control Server 
--------------
* serenity.directi.com 

*** 

**Before you start or thinking of deploying application on production , check if you have SSH access on control and production servers** 

**If it happens that your access is not working on control server , please put up a request to dotpw@sysrt.directi.com** 

*** 
### STEPS 

1. Login to control server **serenity.directi.com** 
2. tranform into deploy user
	* `sudo su - deploy` 
		* If sudo isn't working , raise a request to dotpw@sysrt.directi.com 
3. `cd chirkut_deployment/deploy`
4. `exec ssh-agent bash` 
	* Above step does ssh agent magic so that the private keys for deploy user is accessible to production servers via ssh-agent
5. `ssh-add` 
	* `ssh-add -l` , to verify if the private keys are in ssh-agent
6. `HOSTS=xmpp2.chat.pw cap deploy god:stop god:start`
	* god is process monitoring framework , read more at http://god.rubyforge.org/
	* above command will do the normal deployment 
7. `HOSTS=xmpp1.chat.pw cap deploy god:stop god:start`

**cap script needs lot of improvement , mostly what the way its  been configured right now I would better term it as wrokaround solution need at that time -saurabh.ve** 

        [deploy@serenity.directi.com deploy]$ cap app:status 
          * executing `app:status'
          * executing "sudo /usr/bin/ruby /usr/bin/god status"
            servers: ["xmpp1.chat.pw", "xmpp2.chat.pw"]
            [xmpp1.chat.pw] executing command
            [xmpp2.chat.pw] executing command
         ** [out :: xmpp2.chat.pw] chirkut:
         ** [out :: xmpp2.chat.pw] chirkut-10280: up
         ** [out :: xmpp1.chat.pw] chirkut:
         ** [out :: xmpp1.chat.pw] chirkut-10280: up
            command finished in 1219ms
        [deploy@serenity.directi.com deploy]$ cap app:version
          * executing `app:version'
          * executing "cd /opt/chirkut/chirkut_node.js/current/ && chirkut.js --version"
            servers: ["xmpp1.chat.pw", "xmpp2.chat.pw"]
            [xmpp1.chat.pw] executing command
            [xmpp2.chat.pw] executing command
         ** [out :: xmpp1.chat.pw] chirkut.js: BOSH server version 0.0.20
         ** [out :: xmpp2.chat.pw] chirkut.js: BOSH server version 0.0.20
            command finished in 324ms
        [deploy@serenity.directi.com deploy]$ cap deploy:check
          * executing `deploy:check'
          * executing "test -d /opt/chirkut/chirkut_node.js/releases"
            servers: ["xmpp1.chat.pw", "xmpp2.chat.pw"]
            [xmpp2.chat.pw] executing command
            [xmpp1.chat.pw] executing command
            command finished in 79ms
          * executing "test -w /opt/chirkut/chirkut_node.js"
            servers: ["xmpp1.chat.pw", "xmpp2.chat.pw"]
            [xmpp1.chat.pw] executing command
            [xmpp2.chat.pw] executing command
            command finished in 126ms
          * executing "test -w /opt/chirkut/chirkut_node.js/releases"
            servers: ["xmpp1.chat.pw", "xmpp2.chat.pw"]
            [xmpp2.chat.pw] executing command
            [xmpp1.chat.pw] executing command
            command finished in 79ms
          * executing "which git"
            servers: ["xmpp1.chat.pw", "xmpp2.chat.pw"]
            [xmpp2.chat.pw] executing command
            [xmpp1.chat.pw] executing command
            command finished in 79ms
        You appear to have all necessary dependencies installed

# REFRENCES

* http://help.github.com/deploy-with-capistrano/
