// -*- tab-width: 4 -*-

/* Directi Pvt. Ltd. 2011 */

var util = require('util');

function XMPPUtils(nxb, server) {
	this.nxb    = nxb;
	this.server = server;
}

function Temp() { }
Temp.prototype = {
	send_message: function(sstate, text, from_jid) {
		from_jid = from_jid || "message-service@talk.to";
		var msg = new ltx.Element('message', {
			from: from_jid, 
			type: "chat", 
			xmlns: "jabber:client"
		})
		.c('body').t(text).tree();

		this.server.emit('response', msg, sstate);
	}, 

	send_message_to_all: function(text, from_jid) {
		var streams = Object.keys(this.server.sn_state);
		var self = this;

		streams.forEach(function(stream) {
			var sstate = self.server.sn_state[stream];
			self.send_message(sstate, text, from_jid);
		});
	}
};

// We need this hack to make webrepl autocomplete our members for us
util.inherits(XMPPUtils, Temp);

exports.init = function(ctor_args) {
    if (!ctor_args || !ctor_args.server || !ctor_args.nxb || !ctor_args.webrepl) {
		throw new Error("You MUST set 'server', 'nxb' and 'webrepl' to their respective values");
    }

    var utils = new XMPPUtils(ctor_args.nxb, ctor_args.server);
	ctor_args.webrepl.context.utils = utils;
};
