#!/bin/bash

VERSION=`cat package.json | grep "version" | cut -d ' ' -f 2 | sed s/\"//g`
DIR="chirkut.js-$VERSION"
PREVDIR=$PWD
TARFILE="$DIR.tar.gz"

rm -Rf $DIR
mkdir $DIR

cp -R plugins runner.sh package.json README.md release.sh \
run-server.js $DIR

cd $DIR

if [[ $PWD == $PREVDIR ]]; then
  exit 1
fi

find -name "*.bak" | xargs rm

cd ..

tar -zvcf $TARFILE $DIR
