var http=require("http");
exports.decode64=function(encoded)
{
	return (new Buffer(encoded, 'base64')).toString('utf8');
}
exports.encode64=function(decoded)
{
	return (new Buffer(decoded, 'utf8')).toString('base64');
}
exports.randomstring=function()
{
	var l=5+Math.floor(Math.random()*5);
	var chars="0123456789qwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM";
	var str="";
	for(var i=0;i<l;i++)
	{
		var n=Math.floor(Math.random()*chars.length);
		str+=chars.substr(n,1);
	}
	return str;
}
exports.xmlhttprequest=function(options,cb,body)
{
	var hr=http.request(options,function(response){
		var xdata="";
		response.on('data',function(chunk){
			xdata += chunk.toString();
		});
		response.on('end',function(){
			logit("DEBUG","response: "+xdata);
			cb(false,xdata);
		});
		response.on('error',function(ee){
			cb(true,ee.toString());
		});
	});
	hr.setHeader("Connection", "Keep-Alive");
	hr.on('error',function(ee){
		cb(true,ee.toString());
	});
	logit("DEBUG","request: "+body);
	if(body)
	{
		hr.setHeader("Content-Type","text/xml; charset=utf-8");
		hr.setHeader("Content-Length",body.length.toString());
		hr.write(body);
	}
	hr.end();
}
var loglevel;
exports.setloglevel=function(ss)
{
	ss=ss.toUpperCase();
	if(!loglevels[ss])
		ss="INFO";
	loglevel=ss;
}
var loglevels={
	FATAL:0,
	ERROR:1,
	DATA:2,
	INFO:3,
	DEBUG:4,
};
function logit(type,quote)
{
	//handle logging levels
	if(loglevels[type])
	{
		if(loglevels[type]<=loglevels[loglevel])
			console.log(type+": "+quote);
	}
}
exports.logit=logit;
